Index: trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/classes.nib	(revision 26)
+++ trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/classes.nib	(revision 26)
@@ -0,0 +1,14 @@
+{
+    IBClasses = (
+        {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
+        {CLASS = NJRScrollView; LANGUAGE = ObjC; SUPERCLASS = NSScrollView; }, 
+        {
+            ACTIONS = {remove = id; }; 
+            CLASS = PSAlarmsController; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {removeButton = NSButton; tableView = NSTableView; }; 
+            SUPERCLASS = NSWindowController; 
+        }
+    ); 
+    IBVersion = 1; 
+}
Index: trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/info.nib	(revision 26)
+++ trunk/Cocoa/Pester/Source/English.lproj/Alarms.nib/info.nib	(revision 26)
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist SYSTEM "file://localhost/System/Library/DTDs/PropertyList.dtd">
+<plist version="0.9">
+<dict>
+	<key>IBDocumentLocation</key>
+	<string>430 17 356 240 0 0 1280 832 </string>
+	<key>IBFramework Version</key>
+	<string>263.2</string>
+	<key>IBOpenObjects</key>
+	<array>
+		<integer>8</integer>
+	</array>
+	<key>IBSystem Version</key>
+	<string>5S66</string>
+</dict>
+</plist>
Index: trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 24)
+++ trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 26)
@@ -3,4 +3,10 @@
         {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
         {CLASS = NJRDateFormatter; LANGUAGE = ObjC; SUPERCLASS = NSDateFormatter; }, 
+        {
+            ACTIONS = {clearAllEntries = id; removeEntry = id; }; 
+            CLASS = NJRHistoryTrackingComboBox; 
+            LANGUAGE = ObjC; 
+            SUPERCLASS = NSComboBox; 
+        }, 
         {CLASS = NJRIntegerFilter; LANGUAGE = ObjC; SUPERCLASS = NSNumberFormatter; }, 
         {
@@ -20,4 +26,16 @@
             }; 
             SUPERCLASS = NSWindowController; 
+        }, 
+        {
+            CLASS = PSAlarmsController; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {tableView = NSTableView; }; 
+            SUPERCLASS = NSWindowController; 
+        }, 
+        {
+            ACTIONS = {orderFrontAlarmsPanel = id; }; 
+            CLASS = PSApplication; 
+            LANGUAGE = ObjC; 
+            SUPERCLASS = NSApplication; 
         }
     ); 
Index: trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 24)
+++ trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 26)
@@ -1,22 +1,22 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
-<plist version="1.0">
+<!DOCTYPE plist SYSTEM "file://localhost/System/Library/DTDs/PropertyList.dtd">
+<plist version="0.9">
 <dict>
 	<key>IBDocumentLocation</key>
-	<string>67 8 356 240 0 0 1600 1178 </string>
+	<string>21 12 356 240 0 0 1280 832 </string>
 	<key>IBEditorPositions</key>
 	<dict>
 		<key>29</key>
-		<string>69 252 273 44 0 0 1600 1178 </string>
+		<string>25 266 273 44 0 0 1280 832 </string>
 	</dict>
 	<key>IBFramework Version</key>
-	<string>286.0</string>
+	<string>263.2</string>
 	<key>IBOpenObjects</key>
 	<array>
+		<integer>21</integer>
 		<integer>29</integer>
-		<integer>21</integer>
 	</array>
 	<key>IBSystem Version</key>
-	<string>6D52</string>
+	<string>5S66</string>
 </dict>
 </plist>
Index: trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib	(revision 24)
+++ trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib	(revision 26)
@@ -1,16 +1,12 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
-<plist version="1.0">
+<!DOCTYPE plist SYSTEM "file://localhost/System/Library/DTDs/PropertyList.dtd">
+<plist version="0.9">
 <dict>
 	<key>IBDocumentLocation</key>
-	<string>571 131 356 240 0 0 1600 1178 </string>
+	<string>424 83 356 240 0 0 1280 832 </string>
 	<key>IBFramework Version</key>
-	<string>286.0</string>
-	<key>IBOpenObjects</key>
-	<array>
-		<integer>5</integer>
-	</array>
+	<string>263.2</string>
 	<key>IBSystem Version</key>
-	<string>6D52</string>
+	<string>5S66</string>
 </dict>
 </plist>
Index: trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.h
===================================================================
--- trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.h	(revision 26)
+++ trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.h	(revision 26)
@@ -0,0 +1,19 @@
+//
+//  NJRHistoryTrackingComboBox.h
+//  DockCam
+//
+//  Created by Nicholas Riley on Fri Jun 28 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <Cocoa/Cocoa.h>
+
+
+@interface NJRHistoryTrackingComboBox : NSComboBox {
+
+}
+
+- (IBAction)removeEntry:(id)sender;
+- (IBAction)clearAllEntries:(id)sender;
+
+@end
Index: trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m	(revision 26)
+++ trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m	(revision 26)
@@ -0,0 +1,75 @@
+//
+//  NJRHistoryTrackingComboBox.m
+//  DockCam
+//
+//  Created by Nicholas Riley on Fri Jun 28 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NJRHistoryTrackingComboBox.h"
+
+#define NJRHistoryTrackingComboBoxMaxItems 10
+
+@implementation NJRHistoryTrackingComboBox
+
+- (NSString *)_defaultKey;
+{
+    NSAssert([self tag] != 0, @"CanÕt track history for combo box with tag 0: please set a tag");
+    return [NSString stringWithFormat: @"NJRHistoryTrackingComboBox tag %d", [self tag]];
+}
+
+- (void)awakeFromNib;
+{
+    NSAssert([self tag] != 0, @"CanÕt track history for combo box with tag 0: please set a tag");
+    [[NSNotificationCenter defaultCenter] addObserver: self
+                                             selector: @selector(textDidEndEditing:)
+                                                 name: NSTextDidEndEditingNotification
+                                               object: self];
+    [self removeAllItems];
+    [self addItemsWithObjectValues: [[NSUserDefaults standardUserDefaults] stringArrayForKey: [self _defaultKey]]];
+    [self setItemHeight: [self itemHeight] + 2];
+}
+
+- (void)_writeHistory;
+{
+    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    [defaults setObject: [self objectValues] forKey: [self _defaultKey]];
+    [defaults synchronize];
+}
+
+- (IBAction)removeEntry:(id)sender;
+{
+    int idx = [self indexOfSelectedItem];
+    if (idx == -1) {
+        [self selectItemWithObjectValue: [self stringValue]];
+        idx = [self indexOfSelectedItem];
+    }
+    if (idx != -1) [self removeItemAtIndex: idx];
+    [self setStringValue: @""];
+    [self _writeHistory];
+}
+
+- (IBAction)clearAllEntries:(id)sender;
+{
+    [self removeAllItems];
+    [self setStringValue: @""];
+    [self _writeHistory];
+}
+
+- (BOOL)textShouldEndEditing:(NSText *)textObject;
+{
+    NSString *newValue = [self stringValue];
+    int oldIndex = [self indexOfItemWithObjectValue: newValue];
+    [self removeItemWithObjectValue: newValue];
+    [self insertItemWithObjectValue: newValue atIndex: 0];
+    if (oldIndex == NSNotFound) {
+        int numItems = [self numberOfItems];
+        while (numItems-- > NJRHistoryTrackingComboBoxMaxItems) {
+            [self removeItemAtIndex: numItems - 1];
+        }
+    }
+    [self _writeHistory];
+    return YES;
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/NSTableView-NJRExtensions.h
===================================================================
--- trunk/Cocoa/Pester/Source/NSTableView-NJRExtensions.h	(revision 26)
+++ trunk/Cocoa/Pester/Source/NSTableView-NJRExtensions.h	(revision 26)
@@ -0,0 +1,16 @@
+//
+//  NSTableView-NJRExtensions.h
+//  HostLauncher
+//
+//  Created by Nicholas Riley on Mon Apr 22 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <Cocoa/Cocoa.h>
+
+
+@interface NSTableView (NJRExtensions)
+
+- (float)cellHeight;
+
+@end
Index: trunk/Cocoa/Pester/Source/NSTableView-NJRExtensions.m
===================================================================
--- trunk/Cocoa/Pester/Source/NSTableView-NJRExtensions.m	(revision 26)
+++ trunk/Cocoa/Pester/Source/NSTableView-NJRExtensions.m	(revision 26)
@@ -0,0 +1,25 @@
+//
+//  NSTableView-NJRExtensions.m
+//  HostLauncher
+//
+//  Created by Nicholas Riley on Mon Apr 22 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NSTableView-NJRExtensions.h"
+
+
+@implementation NSTableView (NJRExtensions)
+
+- (float)cellHeight;
+{
+    return [self rowHeight] + [self intercellSpacing].height;
+}
+
+// causes NSTableView to get keyboard focus (with thanks to Pierre-Olivier Latour)
+- (BOOL)needsPanelToBecomeKey
+{
+    return YES;
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/PSAlarm.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarm.h	(revision 24)
+++ trunk/Cocoa/Pester/Source/PSAlarm.h	(revision 26)
@@ -10,8 +10,11 @@
 
 typedef enum {
-    PSAlarmInvalid, PSAlarmInterval, PSAlarmDate
+    PSAlarmInvalid, PSAlarmInterval, PSAlarmDate, PSAlarmSet
 } PSAlarmType;
 
-@interface PSAlarm : NSObject {
+extern NSString * const PSAlarmTimerSetNotification;
+extern NSString * const PSAlarmTimerExpiredNotification;
+
+@interface PSAlarm : NSObject <NSCoding> {
     PSAlarmType alarmType;
     NSCalendarDate *alarmDate;
@@ -19,8 +22,9 @@
     NSString *alarmMessage;
     NSString *invalidMessage;
+    NSTimer *timer;
 }
 
 - (void)setInterval:(NSTimeInterval)anInterval;
-- (void)setForDateAtTime:(NSDate *)dateTime;
+- (void)setForDateAtTime:(NSCalendarDate *)dateTime;
 - (void)setForDate:(NSDate *)date atTime:(NSDate *)time;
 - (void)setMessage:(NSString *)aMessage;
@@ -28,8 +32,11 @@
 - (NSDate *)date;
 - (NSTimeInterval)interval;
+- (NSString *)message;
+- (NSComparisonResult)compare:(PSAlarm *)otherAlarm;
 
 - (BOOL)isValid;
-- (NSString *)message;
 - (NSString *)invalidMessage;
 
+- (BOOL)setTimer;
+
 @end
Index: trunk/Cocoa/Pester/Source/PSAlarm.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 24)
+++ trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 26)
@@ -9,6 +9,19 @@
 #import "PSAlarm.h"
 
+NSString * const PSAlarmTimerSetNotification = @"PSAlarmTimerSetNotification";
+NSString * const PSAlarmTimerExpiredNotification = @"PSAlarmTimerExpiredNotification";
 
 @implementation PSAlarm
+
+- (void)dealloc;
+{
+    // NSLog(@"DEALLOC %@", self);
+    alarmType = PSAlarmInvalid;
+    [alarmDate release]; alarmDate = nil;
+    [alarmMessage release]; alarmMessage = nil;
+    [invalidMessage release]; invalidMessage = nil;
+    [timer release]; timer = nil;
+    [super dealloc];
+}
 
 - (void)_setAlarmDate:(NSCalendarDate *)aDate;
@@ -54,4 +67,5 @@
         [self _invalidate: @"Please specify an alarm interval."]; return;
     }
+    [self _setDateFromInterval];
 }
 
@@ -66,11 +80,7 @@
 }
 
-- (void)setForDateAtTime:(NSDate *)dateTime;
-{
-    if (dateTime != alarmDate) {
-        [alarmDate release];
-        alarmDate = nil;
-        alarmDate = [dateTime retain];
-    }
+- (void)setForDateAtTime:(NSCalendarDate *)dateTime;
+{
+    [self _setAlarmDate: dateTime];
     [self _setIntervalFromDate];
 }
@@ -106,5 +116,6 @@
 - (BOOL)isValid;
 {
-    return (alarmType == PSAlarmInvalid);
+    if (alarmType == PSAlarmDate) [self _setIntervalFromDate];
+    return (alarmType != PSAlarmInvalid);
 }
 
@@ -127,4 +138,5 @@
 - (NSString *)invalidMessage;
 {
+    if (invalidMessage == nil) return @"";
     return invalidMessage;
 }
@@ -138,7 +150,109 @@
 - (NSTimeInterval)interval;
 {
+    if (alarmType == PSAlarmSet) return [timer timeInterval]; // XXX counts down?
     if (alarmType == PSAlarmDate) [self _setIntervalFromDate];
     return alarmInterval;
 }
 
+- (BOOL)setTimer;
+{
+    switch (alarmType) {
+        case PSAlarmDate: if (![self isValid]) return NO;
+        case PSAlarmInterval:
+            timer = [NSTimer scheduledTimerWithTimeInterval: alarmInterval
+                                                     target: self
+                                                   selector: @selector(_timerExpired:)
+                                                   userInfo: nil
+                                                    repeats: NO];
+            if (timer != nil) {
+                alarmType = PSAlarmSet;
+                [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmTimerSetNotification object: self];
+                return YES;
+            }
+        default:
+            return NO;
+    }
+}
+
+- (void)cancel;
+{
+    [timer release]; timer = nil;
+}
+
+- (void)_timerExpired:(NSTimer *)aTimer;
+{
+    [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmTimerExpiredNotification object: self];
+    timer = nil;
+    [timer release];
+}
+
+- (NSString *)_alarmTypeString;
+{
+    switch (alarmType) {
+        case PSAlarmDate: return @"PSAlarmDate";
+        case PSAlarmInterval: return @"PSAlarmInterval";
+        case PSAlarmSet: return @"PSAlarmSet";
+        case PSAlarmInvalid: return @"PSAlarmInvalid";
+        default: return [NSString stringWithFormat: @"<unknown: %u>", alarmType];
+    }
+}
+
+- (NSComparisonResult)compare:(PSAlarm *)otherAlarm;
+{
+    return [[self date] compare: [otherAlarm date]];
+}
+
+- (NSString *)description;
+{
+    return [NSString stringWithFormat: @"%@: type %@ date %@ interval %.1f%@",
+        [super description], [self _alarmTypeString], alarmDate, alarmInterval,
+        (alarmType == PSAlarmInvalid ?
+         [NSString stringWithFormat: @"\ninvalid message: %@", invalidMessage]
+        : (alarmType == PSAlarmSet ?
+           [NSString stringWithFormat: @"\ntimer: %@", timer] : @""))];
+}
+
+- (void)encodeWithCoder:(NSCoder *)coder;
+{
+    if (![self isValid]) return;
+    [coder encodeValueOfObjCType: @encode(PSAlarmType) at: &alarmType];
+    switch (alarmType) {
+        case PSAlarmDate:
+        case PSAlarmSet:
+            [coder encodeObject: alarmDate];
+            break;
+        case PSAlarmInterval:
+            [coder encodeValueOfObjCType: @encode(NSTimeInterval) at: &alarmInterval];
+            break;
+        default:
+            break;
+    }
+    [coder encodeObject: alarmMessage];
+    return;
+}
+
+- (id)initWithCoder:(NSCoder *)coder;
+{
+    if ( (self = [super init]) != nil) {
+        [coder decodeValueOfObjCType: @encode(PSAlarmType) at: &alarmType];
+        switch (alarmType) {
+            case PSAlarmDate:
+            case PSAlarmSet:
+                [self _setAlarmDate: [coder decodeObject]];
+                break;
+            case PSAlarmInterval:
+                [coder decodeValueOfObjCType: @encode(NSTimeInterval) at: &alarmInterval];
+                break;
+            default:
+                break;
+        }
+        [self setMessage: [coder decodeObject]];
+        if (alarmType == PSAlarmSet) {
+            alarmType = PSAlarmDate;
+            [self setTimer];
+        }
+    }
+    return self;
+}
+
 @end
Index: trunk/Cocoa/Pester/Source/PSAlarmNotifierController.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmNotifierController.h	(revision 24)
+++ trunk/Cocoa/Pester/Source/PSAlarmNotifierController.h	(revision 26)
@@ -9,4 +9,5 @@
 #import <AppKit/AppKit.h>
 
+@class PSAlarm;
 
 @interface PSAlarmNotifierController : NSWindowController {
@@ -15,4 +16,8 @@
 }
 
++ (PSAlarmNotifierController *)controllerWithTimerExpiredNotification:(NSNotification *)notification;
+
+- (id)initWithAlarm:(PSAlarm *)alarm;
+
 - (IBAction)close:(NSButton *)sender;
 
Index: trunk/Cocoa/Pester/Source/PSAlarmNotifierController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmNotifierController.m	(revision 24)
+++ trunk/Cocoa/Pester/Source/PSAlarmNotifierController.m	(revision 26)
@@ -12,12 +12,17 @@
 @implementation PSAlarmNotifierController
 
-- (id)initWithTimer:(NSTimer *)timer;
+// XXX should use NSNonactivatingPanelMask on 10.2
+
++ (PSAlarmNotifierController *)controllerWithTimerExpiredNotification:(NSNotification *)notification;
+{
+    return [[self alloc] initWithAlarm: [notification object]];
+}
+
+- (id)initWithAlarm:(PSAlarm *)alarm;
 {
     if ([self initWithWindowNibName: @"Notifier"]) {
-        PSAlarm *alarm = [timer userInfo];
-
         [[self window] center];
         [messageField setStringValue: [alarm message]];
-        [dateField setObjectValue: [timer fireDate]];
+        [dateField setObjectValue: [alarm date]];
         [NSApp activateIgnoringOtherApps: YES];
         [[self window] makeKeyAndOrderFront: nil];
Index: trunk/Cocoa/Pester/Source/PSAlarmSetController.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmSetController.h	(revision 24)
+++ trunk/Cocoa/Pester/Source/PSAlarmSetController.h	(revision 26)
@@ -20,7 +20,8 @@
     IBOutlet NSTextField *timeSummary;
     IBOutlet NSButton *setButton;
+    NSString *status;
+    NSTimer *updateTimer;
     PSAlarm *alarm;
-    NSString *status;
-    BOOL isIn;
+    BOOL isInterval;
 }
 
Index: trunk/Cocoa/Pester/Source/PSAlarmSetController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 24)
+++ trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 26)
@@ -28,4 +28,9 @@
 // XXX please expose the iCal controls!
 
+@interface PSAlarmSetController (Private)
+
+- (void)_stopUpdateTimer;
+
+@end
 
 @implementation PSAlarmSetController
@@ -33,22 +38,17 @@
 - (void)awakeFromNib;
 {
-    // NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    // XXX bugs prevent this code from working properly on Jaguar
+    /* NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    [timeOfDay setFormatter: [[NJRDateFormatter alloc] initWithDateFormat: [defaults objectForKey: NSTimeFormatString] allowNaturalLanguage: YES]];
+    [timeDate setFormatter: [[NJRDateFormatter alloc] initWithDateFormat: [defaults objectForKey: NSShortDateFormatString] allowNaturalLanguage: YES]]; */
+    alarm = [[PSAlarm alloc] init];
     [[self window] center];
-    // XXX bugs prevent these from working (sigh...)
-    // [timeOfDay setFormatter: [[NJRDateFormatter alloc] initWithDateFormat: [defaults objectForKey: NSTimeFormatString] allowNaturalLanguage: YES]];
-    // [timeDate setFormatter: [[NJRDateFormatter alloc] initWithDateFormat: [defaults objectForKey: NSShortDateFormatString] allowNaturalLanguage: YES]];
     [self inAtChanged: nil];
-    alarm = [[PSAlarm alloc] init];
     [[self window] makeKeyAndOrderFront: nil];
 }
 
-- (BOOL)applicationShouldHandleReopen:(NSApplication *)sender hasVisibleWindows:(BOOL)flag;
-{
-    if (!flag) [self showWindow: self];
-    return YES;
-}
-
 - (void)setStatus:(NSString *)aString;
 {
+    // NSLog(@"%@", alarm);
     if (aString != status) {
         [status release]; status = nil;
@@ -74,5 +74,5 @@
 - (void)setAlarmDateAndInterval:(id)sender;
 {
-    if (isIn) {
+    if (isInterval) {
         [alarm setInterval:
             [[self objectValueForTextField: timeInterval whileEditing: sender] intValue] *
@@ -84,19 +84,36 @@
 }
 
-// XXX should set timer to update status every second while configuration is valid, application is in front, and isIn
+- (void)_stopUpdateTimer;
+{
+    if ([updateTimer isValid]) [updateTimer invalidate];
+    [updateTimer release]; updateTimer = nil;
+}
 
 // XXX use OACalendar?
 
-// Be careful not to hook up any of the text fields' actions to update: because we handle them in controlTextDidChange: instead.  If we could get the active text field somehow via public API (guess we could use controlTextDidBegin/controlTextDidEndEditing) then we'd not need to overload the update sender for this purpose.  Or, I guess, we could use another method other than update.  It should not be this hard to implement what is essentially standard behavior.  Sigh.
-
 - (IBAction)updateDateDisplay:(id)sender;
 {
+    // NSLog(@"updateDateDisplay: %@", sender);
     if ([alarm isValid]) {
         [self setStatus: [[alarm date] descriptionWithCalendarFormat: @"Alarm will be set for %X on %x" timeZone: nil locale: nil]];
         [setButton setEnabled: YES];
+        if (updateTimer == nil || ![updateTimer isValid]) {
+            // XXX this logic (and the timer) should really go into PSAlarm, to send notifications for status updates instead.  Timer starts when people are watching, stops when people aren't.
+            // NSLog(@"setting timer");
+            if (isInterval) {
+                updateTimer = [NSTimer scheduledTimerWithTimeInterval: 1 target: self selector: @selector(updateDateDisplay:) userInfo: nil repeats: YES];
+            } else {
+                updateTimer = [NSTimer scheduledTimerWithTimeInterval: [alarm interval] target: self selector: @selector(updateDateDisplay:) userInfo: nil repeats: NO];
+            }
+            [updateTimer retain];
+        }
     } else {
         [setButton setEnabled: NO];
-    }
-}
+        [self setStatus: [alarm invalidMessage]];
+        [self _stopUpdateTimer];
+    }
+}
+
+// Be careful not to hook up any of the text fields' actions to update: because we handle them in controlTextDidChange: instead.  If we could get the active text field somehow via public API (guess we could use controlTextDidBegin/controlTextDidEndEditing) then we'd not need to overload the update sender for this purpose.  Or, I guess, we could use another method other than update.  It should not be this hard to implement what is essentially standard behavior.  Sigh.
 
 - (IBAction)update:(id)sender;
@@ -109,15 +126,54 @@
 - (IBAction)inAtChanged:(id)sender;
 {
-    isIn = ([inAtMatrix selectedTag] == 0);
-    [timeInterval setEnabled: isIn];
-    [timeIntervalUnits setEnabled: isIn];
-    [timeOfDay setEnabled: !isIn];
-    [timeDate setEnabled: !isIn];
-    [timeDateCompletions setEnabled: !isIn];
+    isInterval = ([inAtMatrix selectedTag] == 0);
+    [timeInterval setEnabled: isInterval];
+    [timeIntervalUnits setEnabled: isInterval];
+    [timeOfDay setEnabled: !isInterval];
+    [timeDate setEnabled: !isInterval];
+    [timeDateCompletions setEnabled: !isInterval];
     if (sender != nil)
-        [[self window] makeFirstResponder: isIn ? timeInterval : timeOfDay];
+        [[self window] makeFirstResponder: isInterval ? timeInterval : timeOfDay];
     // NSLog(@"UPDATING FROM inAtChanged");
     [self update: nil];
 }
+
+- (IBAction)dateCompleted:(NSPopUpButton *)sender;
+{
+    [timeDate setStringValue: [sender titleOfSelectedItem]];
+    [self update: sender];
+}
+
+// to ensure proper updating of interval, this should be the only method by which the window is shown (e.g. from the Alarm menu)
+- (IBAction)showWindow:(id)sender;
+{
+    if (![[self window] isVisible]) {
+        // NSLog(@"UPDATING FROM showWindow");
+        [self update: self];
+    }
+    [super showWindow: sender];
+}
+
+- (IBAction)setAlarm:(NSButton *)sender;
+{
+    PSAlarmNotifierController *notifier = [PSAlarmNotifierController alloc];
+    if (notifier == nil) {
+        [self setStatus: @"Unable to set alarm."];
+        return;
+    }
+    [self setAlarmDateAndInterval: sender];
+    [alarm setMessage: [messageField stringValue]];
+    if (![alarm setTimer]) {
+        [self setStatus: [@"Unable to set alarm.  " stringByAppendingString: [alarm invalidMessage]]];
+        return;
+    }
+    [self setStatus: [[alarm date] descriptionWithCalendarFormat: @"Alarm set for %x at %X" timeZone: nil locale: nil]];
+    [[self window] close];
+    [alarm release];
+    alarm = [[PSAlarm alloc] init];
+}
+
+@end
+
+@implementation PSAlarmSetController (NSControlSubclassDelegate)
 
 - (void)control:(NSControl *)control didFailToValidatePartialString:(NSString *)string errorDescription:(NSString *)error;
@@ -140,40 +196,17 @@
 }
 
-- (IBAction)dateCompleted:(NSPopUpButton *)sender;
-{
-    [timeDate setStringValue: [sender titleOfSelectedItem]];
-}
-
-// to ensure proper updating of interval, this should be the only method by which the window is shown (e.g. from the Alarm menu)
-- (IBAction)showWindow:(id)sender;
-{
-    if (![[self window] isVisible]) {
-        // NSLog(@"UPDATING FROM showWindow");
-        [self update: self];
-    }
-    [super showWindow: sender];
-    
-}
-
-- (IBAction)setAlarm:(NSButton *)sender;
-{
-    PSAlarmNotifierController *notifier = [PSAlarmNotifierController alloc];
-    NSTimer *timer;
-    NSTimeInterval interval;
-    [self setAlarmDateAndInterval: sender];
-    if (notifier == nil || ( (interval = [alarm interval]) == 0)) {
-        [self setStatus: @"Unable to set alarm (time just passed?)"];
-        return;
-    }
-    [alarm setMessage: [messageField stringValue]];
-    // XXX should use alarm object instead for userInfo
-    timer = [NSTimer scheduledTimerWithTimeInterval: interval
-                                             target: notifier
-                                           selector: @selector(initWithTimer:)
-                                           userInfo: alarm
-                                            repeats: NO];
-    [self setStatus: [[alarm date] descriptionWithCalendarFormat: @"Alarm set for %x at %X" timeZone: nil locale: nil]];
-    [[self window] close];
-}
+@end
+
+@implementation PSAlarmSetController (NSWindowNotifications)
+
+- (void)windowWillClose:(NSNotification *)notification;
+{
+    // NSLog(@"stopping update timer");
+    [self _stopUpdateTimer];
+}
+
+@end
+
+@implementation PSAlarmSetController (NSControlSubclassNotifications)
 
 // called because we're the delegate
@@ -186,2 +219,12 @@
 
 @end
+
+@implementation PSAlarmSetController (NSApplicationDelegate)
+
+- (BOOL)applicationShouldHandleReopen:(NSApplication *)sender hasVisibleWindows:(BOOL)flag;
+{
+    if (!flag) [self showWindow: self];
+    return YES;
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/PSAlarms.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarms.h	(revision 26)
+++ trunk/Cocoa/Pester/Source/PSAlarms.h	(revision 26)
@@ -0,0 +1,27 @@
+//
+//  PSAlarms.h
+//  Pester
+//
+//  Created by Nicholas Riley on Fri Oct 11 2002.
+//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
+//
+
+#import <Cocoa/Cocoa.h>
+
+extern NSString * const PSAlarmsDidChangeNotification;
+
+@class PSAlarm;
+
+@interface PSAlarms : NSObject {
+    NSMutableArray *alarms;
+}
+
++ (void)setUp;
++ (PSAlarms *)allAlarms;
+
+- (int)alarmCount;
+- (PSAlarm *)alarmAtIndex:(int)index;
+- (void)removeAlarmAtIndex:(int)index;
+- (void)removeAlarmsAtIndices:(NSArray *)indices;
+
+@end
Index: trunk/Cocoa/Pester/Source/PSAlarms.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 26)
+++ trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 26)
@@ -0,0 +1,117 @@
+//
+//  PSAlarms.m
+//  Pester
+//
+//  Created by Nicholas Riley on Fri Oct 11 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "PSAlarms.h"
+#import "PSAlarm.h"
+
+NSString * const PSAlarmsDidChangeNotification = @"PSAlarmsDidChangeNotification";
+
+static NSString * const PSPendingAlarms = @"Pester pending alarms"; // NSUserDefaults key
+
+static PSAlarms *PSAlarmsAllAlarms = nil;
+
+@implementation PSAlarms
+
++ (void)setUp; // XXX if you can think of a better name, please be my guest.
+{
+    if (PSAlarmsAllAlarms == nil) {
+        PSAlarmsAllAlarms = [[self alloc] init];
+    }
+}
+
++ (PSAlarms *)allAlarms;
+{
+    return PSAlarmsAllAlarms;
+}
+
+- (id)init;
+{
+    if ( (self = [super init]) != nil) {
+        NS_DURING
+            NSData *alarmData = [[NSUserDefaults standardUserDefaults] dataForKey: PSPendingAlarms];
+            if (alarmData != nil) {
+                alarms = [[NSUnarchiver unarchiveObjectWithData: alarmData] retain];
+            }
+        NS_HANDLER
+            // XXX need better error handling here, don't stomp on data
+            NSLog(@"An error occurred while attempting to restore the alarm list: %@", localException);
+        NS_ENDHANDLER
+        if (alarms == nil) alarms = [[NSMutableArray alloc] init];
+        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_alarmTimerSet:) name: PSAlarmTimerSetNotification object: nil];
+        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_alarmTimerExpired:) name: PSAlarmTimerExpiredNotification object: nil];
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [alarms dealloc];
+    [[NSNotificationCenter defaultCenter] removeObserver: self];
+    [super dealloc];
+}
+
+- (void)_changed;
+{
+    NSData *alarmData;
+    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    [alarms sortUsingSelector: @selector(compare:)];
+    alarmData = [NSArchiver archivedDataWithRootObject: alarms];
+    [defaults setObject: alarmData forKey: PSPendingAlarms];
+    [defaults synchronize];
+    // NSLog(@"PSAlarms changed: %@", alarms);
+    [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmsDidChangeNotification object: self];
+}
+
+- (void)_alarmTimerExpired:(NSNotification *)notification;
+{
+    [alarms removeObject: [notification object]];
+    [self _changed];
+}
+
+- (void)_alarmTimerSet:(NSNotification *)notification;
+{
+    [alarms addObject: [notification object]];
+    [self _changed];
+}
+
+- (int)alarmCount;
+{
+    return [alarms count];
+}
+
+- (PSAlarm *)alarmAtIndex:(int)index;
+{
+    return [alarms objectAtIndex: index];
+}
+
+- (void)removeAlarmAtIndex:(int)index;
+{
+    [alarms removeObjectAtIndex: index];
+}
+
+- (void)removeAlarmsAtIndices:(NSArray *)indices;
+{
+    NSEnumerator *e = [indices objectEnumerator];
+    NSNumber *n;
+    int indexCount = [indices count], i = 0;
+    int *indexArray = (int *)malloc(indexCount * sizeof(int));
+    NS_DURING
+        while ( (n = [e nextObject]) != nil) {
+            indexArray[i] = [n intValue];
+            i++;
+        }
+        [alarms removeObjectsFromIndices: indexArray numIndices: indexCount];
+        [self _changed];
+    NS_HANDLER
+        free(indexArray);
+        [self _changed];
+        [localException raise];
+    NS_ENDHANDLER
+}
+
+@end
